diff --git a/python/pyasn1/pyasn1/type/tagmap.py b/python/pyasn1/pyasn1/type/tagmap.py
index 7cec3a10e4..5714487b49 100644
--- a/python/pyasn1/pyasn1/type/tagmap.py
+++ b/python/pyasn1/pyasn1/type/tagmap.py
@@ -21,14 +21,14 @@ class TagMap:
             raise KeyError()
 
     def __repr__(self):
-        s = '%r/%r' % (self.__posMap, self.__negMap)
+        s = '{!r}/{!r}'.format(self.__posMap, self.__negMap)
         if self.__defType is not None:
-            s = s + '/%r' % (self.__defType,)
+            s = s + '/{!r}'.format(self.__defType)
         return s
 
     def clone(self, parentType, tagMap, uniq=False):
         if self.__defType is not None and tagMap.getDef() is not None:
-            raise error.PyAsn1Error('Duplicate default value at %s' % (self,))
+            raise error.PyAsn1Error('Duplicate default value at {}'.format(self))
         if tagMap.getDef() is not None:
             defType = tagMap.getDef()
         else:
@@ -37,7 +37,7 @@ class TagMap:
         posMap = self.__posMap.copy()
         for k in tagMap.getPosMap():
             if uniq and k in posMap:
-                raise error.PyAsn1Error('Duplicate positive key %s' % (k,))
+                raise error.PyAsn1Error('Duplicate positive key {}'.format(k))
             posMap[k] = parentType
 
         negMap = self.__negMap.copy()
diff --git a/python/pyasn1/pyasn1/type/univ.py b/python/pyasn1/pyasn1/type/univ.py
index 9cd16f8a2a..12bdbad339 100644
--- a/python/pyasn1/pyasn1/type/univ.py
+++ b/python/pyasn1/pyasn1/type/univ.py
@@ -55,7 +55,7 @@ class Integer(base.AbstractSimpleAsn1Item):
 
     def __int__(self): return int(self._value)
     if sys.version_info[0] <= 2:
-        def __long__(self): return long(self._value)
+        def __long__(self): return int(self._value)
     def __float__(self): return float(self._value)    
     def __abs__(self): return abs(self._value)
     def __index__(self): return int(self._value)
@@ -73,7 +73,7 @@ class Integer(base.AbstractSimpleAsn1Item):
                 return int(value)
             except:
                 raise error.PyAsn1Error(
-                    'Can\'t coerce %s into integer: %s' % (value, sys.exc_info()[1])
+                    'Can\'t coerce {} into integer: {}'.format(value, sys.exc_info()[1])
                     )
         r = self.__namedValues.getValue(value)
         if r is not None:
@@ -82,7 +82,7 @@ class Integer(base.AbstractSimpleAsn1Item):
             return int(value)
         except:
             raise error.PyAsn1Error(
-                'Can\'t coerce %s into integer: %s' % (value, sys.exc_info()[1])
+                'Can\'t coerce {} into integer: {}'.format(value, sys.exc_info()[1])
                 )
 
     def prettyOut(self, value):
@@ -216,7 +216,7 @@ class BitString(base.AbstractSimpleAsn1Item):
                             r.append(1)
                         else:
                             raise error.PyAsn1Error(
-                                'Non-binary BIT STRING initializer %s' % (v,)
+                                'Non-binary BIT STRING initializer {}'.format(v)
                                 )
                     return tuple(r)
                 elif value[-2:] == '\'H':
@@ -229,14 +229,14 @@ class BitString(base.AbstractSimpleAsn1Item):
                     return tuple(r)
                 else:
                     raise error.PyAsn1Error(
-                        'Bad BIT STRING value notation %s' % (value,)
+                        'Bad BIT STRING value notation {}'.format(value)
                         )                
             else:
                 for i in value.split(','):
                     j = self.__namedValues.getValue(i)
                     if j is None:
                         raise error.PyAsn1Error(
-                            'Unknown bit identifier \'%s\'' % (i,)
+                            'Unknown bit identifier \'{}\''.format(i)
                             )
                     if j >= len(r):
                         r.extend([0]*(j-len(r)+1))
@@ -247,14 +247,14 @@ class BitString(base.AbstractSimpleAsn1Item):
             for b in r:
                 if b and b != 1:
                     raise error.PyAsn1Error(
-                        'Non-binary BitString initializer \'%s\'' % (r,)
+                        'Non-binary BitString initializer \'{}\''.format(r)
                         )
             return r
         elif isinstance(value, BitString):
             return tuple(value)
         else:
             raise error.PyAsn1Error(
-                'Bad BitString initializer type \'%s\'' % (value,)
+                'Bad BitString initializer type \'{}\''.format(value)
                 )
 
     def prettyOut(self, value):
@@ -309,7 +309,7 @@ class OctetString(base.AbstractSimpleAsn1Item):
                     return ''.join([ chr(x) for x in value ])
                 except ValueError:
                     raise error.PyAsn1Error(
-                        'Bad OctetString initializer \'%s\'' % (value,)
+                        'Bad OctetString initializer \'{}\''.format(value)
                         )                
             else:
                 return str(value)
@@ -324,14 +324,14 @@ class OctetString(base.AbstractSimpleAsn1Item):
                     return bytes(value)
                 except ValueError:
                     raise error.PyAsn1Error(
-                        'Bad OctetString initializer \'%s\'' % (value,)
+                        'Bad OctetString initializer \'{}\''.format(value)
                         )
             else:
                 try:
                     return str(value).encode(self._encoding)
                 except UnicodeEncodeError:
                     raise error.PyAsn1Error(
-                        'Can\'t encode string \'%s\' with \'%s\' codec' % (value, self._encoding)
+                        'Can\'t encode string \'{}\' with \'{}\' codec'.format(value, self._encoding)
                         )
                         
 
@@ -350,7 +350,7 @@ class OctetString(base.AbstractSimpleAsn1Item):
                 v = 1
             else:
                 raise error.PyAsn1Error(
-                    'Non-binary OCTET STRING initializer %s' % (v,)
+                    'Non-binary OCTET STRING initializer {}'.format(v)
                     )
             byte = byte | (v << bitNo)
         return octets.ints2octs(r + (byte,))
@@ -421,14 +421,14 @@ class OctetString(base.AbstractSimpleAsn1Item):
     def __rmul__(self, value): return self * value
 
 class Null(OctetString):
-    defaultValue = ''.encode()  # This is tightly constrained
+    defaultValue = b''  # This is tightly constrained
     tagSet = baseTagSet = tag.initTagSet(
         tag.Tag(tag.tagClassUniversal, tag.tagFormatSimple, 0x05)
         )
-    subtypeSpec = OctetString.subtypeSpec+constraint.SingleValueConstraint(''.encode())
+    subtypeSpec = OctetString.subtypeSpec+constraint.SingleValueConstraint(b'')
     
 if sys.version_info[0] <= 2:
-    intTypes = (int, long)
+    intTypes = int
 else:
     intTypes = int
 
@@ -496,7 +496,7 @@ class ObjectIdentifier(base.AbstractSimpleAsn1Item):
         for x in value:
             if not isinstance(x, intTypes) or x < 0:
                 raise error.PyAsn1Error(
-                    'Invalid sub-ID in %s at %s' % (value, self.__class__.__name__)
+                    'Invalid sub-ID in {} at {}'.format(value, self.__class__.__name__)
                     )
     
         return value
@@ -529,11 +529,11 @@ class Real(base.AbstractSimpleAsn1Item):
             for d in value:
                 if not isinstance(d, intTypes):
                     raise error.PyAsn1Error(
-                        'Lame Real value syntax: %s' % (value,)
+                        'Lame Real value syntax: {}'.format(value)
                         )
             if value[1] not in (2, 10):
                 raise error.PyAsn1Error(
-                    'Prohibited base for Real value: %s' % (value[1],)
+                    'Prohibited base for Real value: {}'.format(value[1])
                     )
             if value[1] == 10:
                 value = self.__normalizeBase10(value)
@@ -557,7 +557,7 @@ class Real(base.AbstractSimpleAsn1Item):
             except ValueError:
                 pass
         raise error.PyAsn1Error(
-            'Bad real value syntax: %s' % (value,)
+            'Bad real value syntax: {}'.format(value)
             )
         
     def prettyOut(self, value):
@@ -594,7 +594,7 @@ class Real(base.AbstractSimpleAsn1Item):
 
     def __int__(self): return int(float(self))
     if sys.version_info[0] <= 2:
-        def __long__(self): return long(float(self))
+        def __long__(self): return int(float(self))
     def __float__(self):
         if self._value in self._inf:
             return self._value
@@ -653,7 +653,7 @@ class SetOf(base.AbstractConstructedAsn1Item):
     def _verifyComponent(self, idx, value):
         if self._componentType is not None and \
                not self._componentType.isSuperTypeOf(value):
-            raise error.PyAsn1Error('Component type error %s' % (value,))
+            raise error.PyAsn1Error('Component type error {}'.format(value))
 
     def getComponentByPosition(self, idx): return self._componentValues[idx]
     def setComponentByPosition(self, idx, value=None, verifyConstraints=True):
@@ -748,7 +748,7 @@ class SequenceAndSetBase(base.AbstractConstructedAsn1Item):
                 )
         t = self._componentType[idx].getType()
         if not t.isSuperTypeOf(value):
-            raise error.PyAsn1Error('Component type error %r vs %r' % (t, value))
+            raise error.PyAsn1Error('Component type error {!r} vs {!r}'.format(t, value))
 
     def getComponentByName(self, name):
         return self.getComponentByPosition(
@@ -815,7 +815,7 @@ class SequenceAndSetBase(base.AbstractConstructedAsn1Item):
             elif not self._componentType[idx].isOptional:
                 if self.getComponentByPosition(idx) is None:
                     raise error.PyAsn1Error(
-                        'Uninitialized component #%s at %r' % (idx, self)
+                        'Uninitialized component #{} at {!r}'.format(idx, self)
                         )
 
     def prettyPrint(self, scope=0):
@@ -829,7 +829,7 @@ class SequenceAndSetBase(base.AbstractConstructedAsn1Item):
                     r = r + '<no-name>'
                 else:
                     r = r + componentType.getNameByPosition(idx)
-                r = '%s=%s\n' % (
+                r = '{}={}\n'.format(
                     r, self._componentValues[idx].prettyPrint(scope)
                     )
         return r
diff --git a/python/pyasn1/setup.py b/python/pyasn1/setup.py
index 194f0c8ca8..9637798bc4 100644
--- a/python/pyasn1/setup.py
+++ b/python/pyasn1/setup.py
@@ -4,6 +4,7 @@
    A pure-Python implementation of ASN.1 types and DER/BER/CER codecs (X.208).
 """
 
+from __future__ import print_function
 import os
 import sys
 
diff --git a/python/pyasn1/test/codec/ber/suite.py b/python/pyasn1/test/codec/ber/suite.py
index 796c526b4b..4227dc1cfb 100644
--- a/python/pyasn1/test/codec/ber/suite.py
+++ b/python/pyasn1/test/codec/ber/suite.py
@@ -1,7 +1,7 @@
 from sys import path, version_info
 from os.path import sep
 path.insert(1, path[0]+sep+'ber')
-import test_encoder, test_decoder
+from . import test_encoder, test_decoder
 from pyasn1.error import PyAsn1Error
 if version_info[0:2] < (2, 7) or \
    version_info[0:2] in ( (3, 0), (3, 1) ):
diff --git a/python/pyasn1/test/codec/cer/suite.py b/python/pyasn1/test/codec/cer/suite.py
index 49d682918b..eecccbc5b5 100644
--- a/python/pyasn1/test/codec/cer/suite.py
+++ b/python/pyasn1/test/codec/cer/suite.py
@@ -1,7 +1,7 @@
 from sys import path, version_info
 from os.path import sep
 path.insert(1, path[0]+sep+'cer')
-import test_encoder, test_decoder
+from . import test_encoder, test_decoder
 from pyasn1.error import PyAsn1Error
 if version_info[0:2] < (2, 7) or \
    version_info[0:2] in ( (3, 0), (3, 1) ):
diff --git a/python/pyasn1/test/codec/der/suite.py b/python/pyasn1/test/codec/der/suite.py
index 7af83bf94f..7d73e3aa87 100644
--- a/python/pyasn1/test/codec/der/suite.py
+++ b/python/pyasn1/test/codec/der/suite.py
@@ -1,7 +1,7 @@
 from sys import path, version_info
 from os.path import sep
 path.insert(1, path[0]+sep+'der')
-import test_encoder, test_decoder
+from . import test_encoder, test_decoder
 from pyasn1.error import PyAsn1Error
 if version_info[0:2] < (2, 7) or \
    version_info[0:2] in ( (3, 0), (3, 1) ):
diff --git a/python/pyasn1/test/codec/der/test_decoder.py b/python/pyasn1/test/codec/der/test_decoder.py
index 5c9a1948b9..f2718d2115 100644
--- a/python/pyasn1/test/codec/der/test_decoder.py
+++ b/python/pyasn1/test/codec/der/test_decoder.py
@@ -14,7 +14,7 @@ else:
 class OctetStringDecoderTestCase(unittest.TestCase):
     def testShortMode(self):
         assert decoder.decode(
-            '\004\017Quick brown fox'.encode()
-            ) == ('Quick brown fox'.encode(), ''.encode())
+            b'\004\017Quick brown fox'
+            ) == (b'Quick brown fox', b'')
 
 if __name__ == '__main__': unittest.main()
diff --git a/python/pyasn1/test/codec/suite.py b/python/pyasn1/test/codec/suite.py
index 93ff063818..fe44b6bd50 100644
--- a/python/pyasn1/test/codec/suite.py
+++ b/python/pyasn1/test/codec/suite.py
@@ -1,11 +1,11 @@
 from sys import path, version_info
 from os.path import sep
 path.insert(1, path[0]+sep+'codec'+sep+'ber')
-import ber.suite
+from . import ber.suite
 path.insert(1, path[0]+sep+'codec'+sep+'cer')
-import cer.suite
+from . import cer.suite
 path.insert(1, path[0]+sep+'codec'+sep+'der')
-import der.suite
+from . import der.suite
 from pyasn1.error import PyAsn1Error
 if version_info[0:2] < (2, 7) or \
    version_info[0:2] in ( (3, 0), (3, 1) ):
diff --git a/python/pyasn1/test/suite.py b/python/pyasn1/test/suite.py
index b4d80e864a..11b121b2ce 100644
--- a/python/pyasn1/test/suite.py
+++ b/python/pyasn1/test/suite.py
@@ -1,9 +1,9 @@
 from sys import path, version_info
 from os.path import sep
 path.insert(1, path[0]+sep+'type')
-import type.suite
+from . import type.suite
 path.insert(1, path[0]+sep+'codec')
-import codec.suite
+from . import codec.suite
 from pyasn1.error import PyAsn1Error
 if version_info[0:2] < (2, 7) or \
    version_info[0:2] in ( (3, 0), (3, 1) ):
diff --git a/python/pyasn1/test/type/suite.py b/python/pyasn1/test/type/suite.py
index bc4b48685f..5dc46b0293 100644
--- a/python/pyasn1/test/type/suite.py
+++ b/python/pyasn1/test/type/suite.py
@@ -1,4 +1,4 @@
-import test_tag, test_constraint, test_namedtype, test_univ
+from . import test_tag, test_constraint, test_namedtype, test_univ
 from pyasn1.error import PyAsn1Error
 from sys import version_info
 if version_info[0:2] < (2, 7) or \
diff --git a/python/pylru/pylru.py b/python/pylru/pylru.py
index e69cadb76c..99efcdd406 100644
--- a/python/pylru/pylru.py
+++ b/python/pylru/pylru.py
@@ -1,4 +1,3 @@
-
 # Cache implementaion with a Least Recently Used (LRU) replacement policy and
 # a basic dictionary interface.
 
@@ -32,12 +31,12 @@
 # lookup of values by key.
 
 # Class for the node objects.
-class _dlnode(object):
+class _dlnode:
     def __init__(self):
         self.empty = True
 
 
-class lrucache(object):
+class lrucache:
 
     def __init__(self, size, callback=None):
 
@@ -287,7 +286,7 @@ class lrucache(object):
 
 
 
-class WriteThroughCacheManager(object):
+class WriteThroughCacheManager:
     def __init__(self, store, size):
         self.store = store
         self.cache = lrucache(size)
@@ -354,20 +353,20 @@ class WriteThroughCacheManager(object):
             pass
 
     def __iter__(self):
-        return self.keys()
+        return list(self.keys())
 
     def keys(self):
-        return self.store.keys()
+        return list(self.store.keys())
 
     def values(self):
-        return self.store.values()
+        return list(self.store.values())
 
     def items(self):
-        return self.store.items()
+        return list(self.store.items())
 
 
 
-class WriteBackCacheManager(object):
+class WriteBackCacheManager:
     def __init__(self, store, size):
         self.store = store
 
@@ -454,7 +453,7 @@ class WriteBackCacheManager(object):
 
 
     def __iter__(self):
-        return self.keys()
+        return list(self.keys())
 
     def keys(self):
         for key in self.store.keys():
@@ -501,7 +500,7 @@ class WriteBackCacheManager(object):
         return False
 
 
-class FunctionCacheManager(object):
+class FunctionCacheManager:
     def __init__(self, func, size):
         self.func = func
         self.cache = lrucache(size)
@@ -533,7 +532,7 @@ def lruwrap(store, size, writeback=False):
 
 import functools
 
-class lrudecorator(object):
+class lrudecorator:
     def __init__(self, size):
         self.cache = lrucache(size)
 
diff --git a/python/pylru/test.py b/python/pylru/test.py
index 7a4842fb52..67d170dc94 100644
--- a/python/pylru/test.py
+++ b/python/pylru/test.py
@@ -1,4 +1,3 @@
-
 from pylru import *
 import random
 
@@ -112,7 +111,7 @@ def testcache():
             q2.append((x, y))
 
         assert list(a.items()) == q2
-        assert list(zip(a.keys(), a.values())) == q2
+        assert list(zip(list(a.keys()), list(a.values()))) == q2
         assert list(a.keys()) == list(a)
 
 
diff --git a/python/pystache/pystache/commands/render.py b/python/pystache/pystache/commands/render.py
index 1a9c309d52..c398a9f92c 100644
--- a/python/pystache/pystache/commands/render.py
+++ b/python/pystache/pystache/commands/render.py
@@ -1,5 +1,3 @@
-# coding: utf-8
-
 """
 This module provides command-line access to pystache.
 
@@ -8,6 +6,8 @@ Run this script using the -h option for command-line help.
 """
 
 
+from __future__ import print_function
+import six
 try:
     import json
 except:
@@ -22,7 +22,7 @@ except:
         from sys import exc_info
         ex_type, ex_value, tb = exc_info()
         new_ex = Exception("%s: %s" % (ex_type.__name__, ex_value))
-        raise new_ex.__class__, new_ex, tb
+        six.reraise(new_ex.__class__, new_ex, tb)
 
 # The optparse module is deprecated in Python 2.7 in favor of argparse.
 # However, argparse is not available in Python 2.6 and earlier.
@@ -88,7 +88,7 @@ def main(sys_argv=sys.argv):
         context = json.loads(context)
 
     rendered = renderer.render(template, context)
-    print rendered
+    print(rendered)
 
 
 if __name__=='__main__':
diff --git a/python/pystache/pystache/commands/test.py b/python/pystache/pystache/commands/test.py
index 0872453388..0f530e67ac 100644
--- a/python/pystache/pystache/commands/test.py
+++ b/python/pystache/pystache/commands/test.py
@@ -1,5 +1,3 @@
-# coding: utf-8
-
 """
 This module provides a command to test pystache (unit tests, doctests, etc).
 
diff --git a/python/pystache/pystache/common.py b/python/pystache/pystache/common.py
index fb266dd8b5..f2b2b477f0 100644
--- a/python/pystache/pystache/common.py
+++ b/python/pystache/pystache/common.py
@@ -1,5 +1,3 @@
-# coding: utf-8
-
 """
 Exposes functionality needed throughout the project.
 
@@ -13,9 +11,9 @@ def _get_string_types():
     #   and byte strings, and 2to3 seems to convert all of "str", "unicode",
     #   and "basestring" to Python 3's "str".
     if version_info < (3, ):
-         return basestring
+         return str
     # The latter evaluates to "bytes" in Python 3 -- even after conversion by 2to3.
-    return (unicode, type(u"a".encode('utf-8')))
+    return (str, type(b"a"))
 
 
 _STRING_TYPES = _get_string_types()
@@ -53,7 +51,7 @@ def read(path):
         f.close()
 
 
-class MissingTags(object):
+class MissingTags:
 
     """Contains the valid values for Renderer.missing_tags."""
 
diff --git a/python/pystache/pystache/context.py b/python/pystache/pystache/context.py
index 6715916092..3019146d98 100644
--- a/python/pystache/pystache/context.py
+++ b/python/pystache/pystache/context.py
@@ -1,5 +1,3 @@
-# coding: utf-8
-
 """
 Exposes a ContextStack class.
 
@@ -18,7 +16,7 @@ from pystache.common import PystacheError
 
 
 # This equals '__builtin__' in Python 2 and 'builtins' in Python 3.
-_BUILTIN_MODULE = type(0).__module__
+_BUILTIN_MODULE = int.__module__
 
 
 # We use this private global variable as a return value to represent a key
@@ -29,7 +27,7 @@ _BUILTIN_MODULE = type(0).__module__
 # TODO: eliminate the need for a private global variable, e.g. by using the
 #   preferred Python approach of "easier to ask for forgiveness than permission":
 #     http://docs.python.org/glossary.html#term-eafp
-class NotFound(object):
+class NotFound:
     pass
 _NOT_FOUND = NotFound()
 
@@ -88,10 +86,10 @@ class KeyNotFoundError(PystacheError):
         self.details = details
 
     def __str__(self):
-        return "Key %s not found: %s" % (repr(self.key), self.details)
+        return "Key {} not found: {}".format(repr(self.key), self.details)
 
 
-class ContextStack(object):
+class ContextStack:
 
     """
     Provides dictionary-like access to a stack of zero or more items.
@@ -140,7 +138,7 @@ class ContextStack(object):
         "ContextStack({'alpha': 'abc'}, {'numeric': 123})"
 
         """
-        return "%s%s" % (self.__class__.__name__, tuple(self._stack))
+        return "{}{}".format(self.__class__.__name__, tuple(self._stack))
 
     @staticmethod
     def create(*context, **kwargs):
diff --git a/python/pystache/pystache/defaults.py b/python/pystache/pystache/defaults.py
index bcfdf4cd3a..39c4c3b655 100644
--- a/python/pystache/pystache/defaults.py
+++ b/python/pystache/pystache/defaults.py
@@ -1,5 +1,3 @@
-# coding: utf-8
-
 """
 This module provides a central location for defining default behavior.
 
@@ -39,7 +37,7 @@ STRING_ENCODING = sys.getdefaultencoding()
 FILE_ENCODING = sys.getdefaultencoding()
 
 # The delimiters to start with when parsing.
-DELIMITERS = (u'{{', u'}}')
+DELIMITERS = ('{{', '}}')
 
 # How to handle missing tags when rendering a template.
 MISSING_TAGS = MissingTags.ignore
diff --git a/python/pystache/pystache/init.py b/python/pystache/pystache/init.py
index 38bb1f5a0e..72160475e3 100644
--- a/python/pystache/pystache/init.py
+++ b/python/pystache/pystache/init.py
@@ -1,5 +1,3 @@
-# encoding: utf-8
-
 """
 This module contains the initialization logic called by __init__.py.
 
diff --git a/python/pystache/pystache/loader.py b/python/pystache/pystache/loader.py
index d4a7e5310f..682d8511e1 100644
--- a/python/pystache/pystache/loader.py
+++ b/python/pystache/pystache/loader.py
@@ -1,5 +1,3 @@
-# coding: utf-8
-
 """
 This module provides a Loader class for locating and reading templates.
 
@@ -24,11 +22,11 @@ def _make_to_unicode():
         """
         if encoding is None:
             encoding = defaults.STRING_ENCODING
-        return unicode(s, encoding, defaults.DECODE_ERRORS)
+        return str(s, encoding, defaults.DECODE_ERRORS)
     return to_unicode
 
 
-class Loader(object):
+class Loader:
 
     """
     Loads the template associated to a name or user-defined object.
@@ -86,7 +84,7 @@ class Loader(object):
     def _make_locator(self):
         return Locator(extension=self.extension)
 
-    def unicode(self, s, encoding=None):
+    def str(self, s, encoding=None):
         """
         Convert a string to unicode using the given encoding, and return it.
 
@@ -104,8 +102,8 @@ class Loader(object):
             Defaults to None.
 
         """
-        if isinstance(s, unicode):
-            return unicode(s)
+        if isinstance(s, str):
+            return str(s)
 
         return self.to_unicode(s, encoding)
 
@@ -119,7 +117,7 @@ class Loader(object):
         if encoding is None:
             encoding = self.file_encoding
 
-        return self.unicode(b, encoding)
+        return self.str(b, encoding)
 
     def load_file(self, file_name):
         """
diff --git a/python/pystache/pystache/locator.py b/python/pystache/pystache/locator.py
index 30c5b01e01..a0df2887eb 100644
--- a/python/pystache/pystache/locator.py
+++ b/python/pystache/pystache/locator.py
@@ -1,5 +1,3 @@
-# coding: utf-8
-
 """
 This module provides a Locator class for finding template files.
 
@@ -13,7 +11,7 @@ from pystache.common import TemplateNotFoundError
 from pystache import defaults
 
 
-class Locator(object):
+class Locator:
 
     def __init__(self, extension=None):
         """
diff --git a/python/pystache/pystache/parsed.py b/python/pystache/pystache/parsed.py
index 372d96c666..3574dcbfa3 100644
--- a/python/pystache/pystache/parsed.py
+++ b/python/pystache/pystache/parsed.py
@@ -1,12 +1,10 @@
-# coding: utf-8
-
 """
 Exposes a class that represents a parsed (or compiled) template.
 
 """
 
 
-class ParsedTemplate(object):
+class ParsedTemplate:
 
     """
     Represents a parsed or compiled template.
@@ -41,10 +39,10 @@ class ParsedTemplate(object):
         """
         # We avoid use of the ternary operator for Python 2.4 support.
         def get_unicode(node):
-            if type(node) is unicode:
+            if type(node) is str:
                 return node
             return node.render(engine, context)
-        parts = map(get_unicode, self._parse_tree)
+        parts = list(map(get_unicode, self._parse_tree))
         s = ''.join(parts)
 
-        return unicode(s)
+        return str(s)
diff --git a/python/pystache/pystache/parser.py b/python/pystache/pystache/parser.py
index 9a4fba235b..6086db45b4 100644
--- a/python/pystache/pystache/parser.py
+++ b/python/pystache/pystache/parser.py
@@ -1,5 +1,3 @@
-# coding: utf-8
-
 """
 Exposes a parse() function to parse template strings.
 
@@ -11,8 +9,8 @@ from pystache import defaults
 from pystache.parsed import ParsedTemplate
 
 
-END_OF_LINE_CHARACTERS = [u'\r', u'\n']
-NON_BLANK_RE = re.compile(ur'^(.)', re.M)
+END_OF_LINE_CHARACTERS = ['\r', '\n']
+NON_BLANK_RE = re.compile(r'^(.)', re.M)
 
 
 # TODO: add some unit tests for this.
@@ -35,7 +33,7 @@ def parse(template, delimiters=None):
     ['Hey ', _SectionNode(key='who', index_begin=12, index_end=21, parsed=[_EscapeNode(key='name'), '!'])]
 
     """
-    if type(template) is not unicode:
+    if type(template) is not str:
         raise Exception("Template is not unicode: %s" % type(template))
     parser = _Parser(delimiters)
     return parser.parse(template)
@@ -94,7 +92,7 @@ class _CommentNode(object):
         return _format(self)
 
     def render(self, engine, context):
-        return u''
+        return ''
 
 
 class _ChangeNode(object):
@@ -106,7 +104,7 @@ class _ChangeNode(object):
         return _format(self)
 
     def render(self, engine, context):
-        return u''
+        return ''
 
 
 class _EscapeNode(object):
@@ -147,7 +145,7 @@ class _PartialNode(object):
     def render(self, engine, context):
         template = engine.resolve_partial(self.key)
         # Indent before rendering.
-        template = re.sub(NON_BLANK_RE, self.indent + ur'\1', template)
+        template = re.sub(NON_BLANK_RE, self.indent + r'\1', template)
 
         return engine.render(template, context)
 
@@ -168,7 +166,7 @@ class _InvertedNode(object):
         # Note that lambdas are considered truthy for inverted sections
         # per the spec.
         if data:
-            return u''
+            return ''
         return self.parsed_section.render(engine, context)
 
 
@@ -218,7 +216,7 @@ class _SectionNode(object):
             parts.append(self.parsed.render(engine, context))
             context.pop()
 
-        return unicode(''.join(parts))
+        return str(''.join(parts))
 
 
 class _Parser(object):
diff --git a/python/pystache/pystache/renderengine.py b/python/pystache/pystache/renderengine.py
index c797b1765a..926d81206d 100644
--- a/python/pystache/pystache/renderengine.py
+++ b/python/pystache/pystache/renderengine.py
@@ -1,5 +1,3 @@
-# coding: utf-8
-
 """
 Defines a class responsible for rendering logic.
 
@@ -19,7 +17,7 @@ def context_get(stack, name):
     return stack.get(name)
 
 
-class RenderEngine(object):
+class RenderEngine:
 
     """
     Provides a render() method.
@@ -160,7 +158,7 @@ class RenderEngine(object):
         if not is_string(val):
             # In case the template is an integer, for example.
             val = self.to_str(val)
-        if type(val) is not unicode:
+        if type(val) is not str:
             val = self.literal(val)
         return self.render(val, context, delimiters)
 
diff --git a/python/pystache/pystache/renderer.py b/python/pystache/pystache/renderer.py
index ff6a90c64b..3902a9e2bf 100644
--- a/python/pystache/pystache/renderer.py
+++ b/python/pystache/pystache/renderer.py
@@ -1,5 +1,3 @@
-# coding: utf-8
-
 """
 This module provides a Renderer class to render templates.
 
@@ -17,7 +15,7 @@ from pystache.specloader import SpecLoader
 from pystache.template_spec import TemplateSpec
 
 
-class Renderer(object):
+class Renderer:
 
     """
     A class for rendering mustache templates.
@@ -130,7 +128,7 @@ class Renderer(object):
         if string_encoding is None:
             string_encoding = defaults.STRING_ENCODING
 
-        if isinstance(search_dirs, basestring):
+        if isinstance(search_dirs, str):
             search_dirs = [search_dirs]
 
         self._context = None
@@ -177,16 +175,16 @@ class Renderer(object):
         """
         # We type-check to avoid "TypeError: decoding Unicode is not supported".
         # We avoid the Python ternary operator for Python 2.4 support.
-        if isinstance(s, unicode):
+        if isinstance(s, str):
             return s
-        return self.unicode(s)
+        return self.str(s)
 
     def _to_unicode_hard(self, s):
         """
         Convert a basestring to a string with type unicode (not subclass).
 
         """
-        return unicode(self._to_unicode_soft(s))
+        return str(self._to_unicode_soft(s))
 
     def _escape_to_unicode(self, s):
         """
@@ -195,9 +193,9 @@ class Renderer(object):
         Returns a unicode string (not subclass).
 
         """
-        return unicode(self.escape(self._to_unicode_soft(s)))
+        return str(self.escape(self._to_unicode_soft(s)))
 
-    def unicode(self, b, encoding=None):
+    def str(self, b, encoding=None):
         """
         Convert a byte string to unicode, using string_encoding and decode_errors.
 
@@ -222,7 +220,7 @@ class Renderer(object):
 
         # TODO: Wrap UnicodeDecodeErrors with a message about setting
         # the string_encoding and decode_errors attributes.
-        return unicode(b, encoding, self.decode_errors)
+        return str(b, encoding, self.decode_errors)
 
     def _make_loader(self):
         """
@@ -230,7 +228,7 @@ class Renderer(object):
 
         """
         return Loader(file_encoding=self.file_encoding, extension=self.file_extension,
-                      to_unicode=self.unicode, search_dirs=self.search_dirs)
+                      to_unicode=self.str, search_dirs=self.search_dirs)
 
     def _make_load_template(self):
         """
@@ -299,7 +297,7 @@ class Renderer(object):
             try:
                 return load_partial(name)
             except TemplateNotFoundError:
-                return u''
+                return ''
 
         return resolve_partial
 
@@ -316,7 +314,7 @@ class Renderer(object):
             try:
                 return context_get(stack, name)
             except KeyNotFoundError:
-                return u''
+                return ''
 
         return resolve_context
 
